#!/usr/bin/perl

#┌─────────────────────────────────
#│ YY-BOARD : admin.cgi - 2019/11/04
#│ copyright (c) KentWeb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  YY-BOARD v10.1 PLUS 2019/11/16
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────


# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
err('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# 認証
check_passwd();

# 条件分岐
if ($in{mente_log}) { mente_log(); }
if ($in{mente_icon}) { mente_icon(); }

# 管理モード
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");
	print <<EOM;
<div id="head">
	<div id="head-in">
	<h2>:: $cf{bbs_title}  ::</h2>
	</div>
</div>
<div id="main">
<div id="main-in">
<div align="center">
<p>選択ボタンを押してください。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
</div>
<table class="form-tbl">
<tr>
	<th colspan="2">処理メニュー</th>
</tr><tr>
	<td class="ta-c"><input type="submit" name="mente_log" value="選択"></td>
	<td>&nbsp; 記事メンテナンス（修正/削除）</td>
</tr><tr>
	<td class="ta-c"><input type="submit" name="mente_icon" value="選択"></td>
	<td>&nbsp; ユーザー登録アイコン管理</td>
</tr><tr>
	<td class="ta-c"><input type="button" value="選択" onclick="javascript:window.location='$cf{bbs_cgi}'"></td>
	<td>&nbsp; 掲示板へ戻る</td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM

	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  記事管理
#-----------------------------------------------------------
sub mente_log {
	# 修正フォーム
	if ($in{job} eq "edit" && $in{no}) {
		
		my @log;
		open(DAT,"$cf{logfile}") or err_msg("open err: $cf{logfile}");
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ext,$w,$h,$chk,$tube) = split(/<>/);

			if ($in{no} == $no) {
				@log = ($name,$eml,$sub,$com,$url,$col,$ico,$color2,$ext,$tube);
				last;
			}
		}
		close(DAT);
		
		if (@log == 0) { err_msg("該当記事は存在しません"); }
		
		# 修正フォーム
		edit_form(@log);
	
	# 修正実行
	} elsif ($in{job} eq "edit2") {
		
		# 入力値補正
		if ($in{url} eq 'http://') { $in{url} = ''; }
		$in{sub} ||= '無題';
		
		# アイコン
		my @icon;
		foreach (@{$cf{icon}}) {
			my ($ico,$nam) = split(/,/);
			push(@icon,$ico);
		}
		
		# データオープン
		my @data;
		open(DAT,"+< $cf{logfile}") or err_msg("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ex,$w,$h,$chk,$tube) = split(/<>/);

			if ($no == $in{no}) {

				# 添付削除
				if ($in{imgdel}) {
					unlink("$cf{upldir}/$in{no}$ex");
					unlink("$cf{upldir}/$in{no}-s$ex") if (-f "$cf{upldir}/$in{no}-s$ex");
					$ex = $w = $h = '';
				}

				$_ = "$no<>$reno<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$in{color}<>$icon[$in{icon}]<>$in{color2}<>$ex<>$w<>$h<>$chk<>$in{youtube}<>\n";
			}
			push(@data,$_);
		}
		
		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事を修正しました");

	# 削除処理
	} elsif ($in{job} eq "dele" && $in{no}) {

		# データオープン
		my @data;
		open(DAT,"+< $cf{logfile}") or err_msg("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ex,$w,$h,$chk) = split(/<>/);

			# 親/子削除
			if ($in{no} == $no || $in{no} == $reno) {
				unlink("$cf{upldir}/$no$ex") if ($ex);
				unlink("$cf{upldir}/$no-s$ex") if (-f "$cf{upldir}/$no-s$ex");
				next;
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事を削除しました");

	# 画像許可
	} elsif ($in{job} eq "perm" && $in{no}) {

		# 許可情報をマッチングし更新
		my @data;
		open(DAT,"+< $cf{logfile}") or err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ex,$w,$h,$chk,$tube) = split(/<>/);

			if ($no == $in{no}) {
				if ($chk == 1) { $chk = 0; } else { $chk = 1; }
				$_ = "$no<>$reno<>$date<>$name<>$eml<>$sub<>$com<>$url<>$host<>$pw<>$col<>$ico<>$color2<>$ex<>$w<>$h<>$chk<>$in{youtube}<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	# 管理を表示
	header("記事メンテナンス（修正/削除）");
	print <<EOM;
<div id="head">
	<div id="head-in">
	<h2>:: $cf{bbs_title}  ::</h2>
	</div>
</div>
<div id="main">
<div id="main-in">
EOM
	back_btn();
	print <<EOM;
<div class="ta-r">
<form action="$cf{bbs_cgi}">
<input type="submit" value="&lt; 掲示板" />
</form>
</div>
<div class="sub-ttl"> 記事メンテナンス（修正/削除）</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}" />
<input type="hidden" name="mente_log" value="1">
<p>処理を選択して送信ボタンを押してください。</p>
処理：
<select name="job">
<option value="edit">編集</option>
<option value="dele">削除</option>
EOM

	if ($cf{img_check}) {
		print qq|<option value="perm">許可\n|;
	}

	print <<EOM;
</select>
<input type="submit" value="送信する" />
EOM

	open(IN,"$cf{logfile}") or &err("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ex,$w,$h,$chk,$tube) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);

		my @col = split(/\s+/, $cf{colors});

		if (length($com) > 120) {
			$com = substr($com,0,120) . '.....略';
		}

		# YouTube
		if ($cf{tube}) {
			$tube =~ s|!([\w\-]{1,})!|<a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="250" height="140" class="tube"></a>|g;
		}

		print qq|<div align="center">\n|;
		if (!$reno) {
			print qq|<div class="main" style="border-color:$color2;">|;
		} else {
			print qq|<div class="sub" style="border-color:$color2;">|;
		}

		print qq|<input type="radio" name="no" value="$no">[$no]\n|;
		print qq|<b>$sub</b> 名前：<b>$name</b> 日時：$date [$host]&nbsp;&nbsp;|;

		if ($ex) {
			print qq|[<a href="$cf{uplurl}/$no$ex" target="_blank">添付</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">承認済</span>]\n|;
				} else {
					print qq|[<span class="red">未承認</span>]\n|;
				}
			}
		}
		print qq|<div class="icon"><img src="$cf{cmnurl}/face//$ico" alt="" /></div><div class="clear"></div>\n|;
		print qq|<div class="com"><span style="color:$col[$col]">$com</span><br />$tube</div>\n|;
		print qq|</div>\n|;
	}
	close(IN);

	print <<EOM;
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  修正フォーム
#-----------------------------------------------------------
sub edit_form {
	my ($name,$eml,$sub,$com,$url,$col,$ico,$color2,$ext,$tube) = @_;
	$com =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';

	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($col == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}
	my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	#if ($color2 eq "") { $color2 = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($col3[$_] eq $color2) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# ユーザー登録アイコン・ファイルの読み込み/追加
	if ($cf{user_icon} == 1) {
		put_iconlist();
	}

	my $op_icon;
	foreach (0 .. $#{$cf{icon}}) {
		my ($fnam,$nam) = split(/,/, $cf{icon}->[$_]);
		if ($fnam eq $ico) {
			$op_icon .= qq|<option value="$_" selected="selected">$nam</option>\n|;
		} else {
			$op_icon .= qq|<option value="$_">$nam</option>\n|;
		}
	}

	header("管理モード &gt; 修正フォーム");
	print <<EOM;
<div id="head">
	<div id="head-in">
	<h2>:: $cf{bbs_title}  ::</h2>
	</div>
</div>
<div id="main">
<div id="main-in">
EOM
	back_btn('mente_log');
	print <<EOM;
<p></p>
<div class="sub-ttl">■ 編集フォーム</div>
<p>▼変更する部分のみ修正して送信ボタンを押して下さい。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}" />
<input type="hidden" name="mente_log" value="1">
<input type="hidden" name="job" value="edit2" />
<input type="hidden" name="no" value="$in{no}" />
<table class="regfm">
<tr>
	<th>名前</th>
	<td><input type="text" name="name" value="$name" size="30" /></td>
</tr><tr>
	<th>E-mail</th>
	<td><input type="text" name="email" value="$eml" size="30" /></td>
</tr><tr>
	<th>件名</th>
	<td><input type="text" name="sub" value="$sub" size="30" /></td>
</tr><tr>
	<th>コメント</th>
	<td>
	<textarea name="comment" cols="50" rows="6">$com</textarea>
	</td>
EOM

	if ($ext) {
		print qq|</tr><tr>\n|;
		print qq|<th>添付</th><td>\n|;
		print qq|[<a href="$cf{uplurl}/$in{no}$ext" target="_blank">添付</a>]&nbsp;\n|;
		print qq|<input type="checkbox" name="imgdel" value="1" style="color:gray; border-width:1px; border-color:rgb(247,185,0); border-style:solid;">削除</td>\n|;
	}

	print <<EOM;
</tr><tr>
	<th>YouTube ID</th>
	<td>
	<a href="$cf{bbs_cgi}?mode=expound" class="expound" data-fancybox-type="iframe" title="YouTube貼付方法">【YouTube\貼\付方法】</a>←クリック<br />
	<textarea name="youtube" cols="60" rows="3">$tube</textarea>
	</td>
</tr><tr>
	<th>URL</th>
	<td><input type="text" name="url" value="$url" size="30" /></td>
</tr><tr>
	<th>アイコン</th>
	<td>
		<select name="icon">
		$op_icon
		</select>
	</td>
</tr><tr>
	<th>枠色</th>
	<td>
		<select name="color2">
		$color_b
		</select>
	</td>
</tr><tr>
	<th>文字色</th>
	<td>$color</td>
</tr>
</table>
<input type="submit" value="送信する" />
</form>
<hr>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  ユーザー登録アイコン管理
#-----------------------------------------------------------
sub mente_icon {

	# アイコン削除
	if ($in{job_dele} && $in{no}) {

		# 削除情報
		my %del;
		foreach ( $cgi->param('no') ) {
			$del{$_}++;
		}
		
		# 削除
		my @log;
		open(DAT,"+< $cf{iconfile}") or cgi_err("open err: $cf{iconfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);
			
			# 削除
			if (defined($del{$no})) {
				unlink("$cf{iconurl}/$no$ex") if ($ex);
				unlink("$cf{iconurl}/$no-s$ex") if (-f "$cf{iconurl}/$no-s$ex");
				next;
			}
			push(@log,$_);
		}
		
		# 更新
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		ico_message("アイコンを削除しました");

	# 修正フォーム
	} elsif ($in{job_edit} && $in{no}) {
		
		my @log;
		open(DAT,"$cf{iconfile}") or err_msg("open err: $cf{iconfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);

			if ($in{no} == $no) {
				@log = ($date,$nam,$sub,$eml,$com,$url,$ex,$icotype);
				last;
			}
		}
		close(DAT);
		
		if (@log == 0) { err_msg("該当アイコンは存在しません"); }
		
		# 修正フォーム
		edit_iconfm(@log);
	
	# 修正実行
	} elsif ($in{job} eq "edit2") {
		
		# 入力値補正
		if ($in{url} eq 'http://') { $in{url} = ''; }
		
		# データオープン
		my (@data,$ext2,$w2,$h2);
		open(DAT,"+< $cf{iconfile}") or err_msg("open err: $cf{iconfile}");
		while (<DAT>) {
			my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);

			if ($no == $in{no}) {

				# アップロード
				if ($in{upfile}) { ($ext2,$w2,$h2) = ico_upload($in{no}); }

				# 添付削除
				if ($in{imgdel}) {
					unlink("$cf{iconurl}/$in{no}$ex");
					unlink("$cf{iconurl}/$in{no}-s$ex") if (-f "$cf{iconurl}/$in{no}-s$ex");
					$ex = $w = $h = '';
				}

				# 添付アップロードの場合
				if ($ext2) {
					# 拡張子変更の場合旧ファイル削除
					if ($ex && $ext2 ne $ex) {
						unlink("$cf{iconurl}/$in{no}$ex");
						unlink("$cf{iconurl}/$in{no}-s$ex") if (-f "$cf{iconurl}/$in{no}-s$ex");
					}
					# 新添付ファイル情報
					($ex,$w,$h) = ($ext2,$w2,$h2);
				}

				$_ = "$no<>$date<>$in{name}<>$in{sub}<>$in{email}<>$in{comment}<>$in{url}<>$hos<>$pw<>$ex<>$w<>$h<>$in{icontype}<>\n";
			}
			push(@data,$_);
		}
		
		# 更新
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		ico_message("アイコンを修正しました");

}
	# 管理を表示
	header("ユーザー登録アイコン管理");
	print <<EOM;
<div id="head">
	<div id="head-in">
	<h2>:: $cf{bbs_title}  ::</h2>
	</div>
</div>
<div id="main">
<div id="main-in">
EOM
	back_btn();
	print <<EOM;
<div class="ta-r">
<form action="$cf{bbs_cgi}">
<input type="submit" value="&lt; 掲示板" />
</form>
</div>
<div class="sub-ttl"> ユーザー登録アイコン管理</div><br />
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="hidden" name="mente_icon" value="1">
<div class="btn">
<input type="submit" name="job_dele" value="削除">&nbsp;&nbsp;
<input type="submit" name="job_edit" value="編集">
</div></div>
<div id="list">
EOM

	open(IN,"$cf{iconfile}") or cgi_err("open err: $cf{iconfile}");
	while (<IN>) {
		my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$only) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);

	my $size = get_size("$cf{iconurl}/$no$ex");

			# 画像情報
			my $picinf;
			if ($ex eq ".gif") {
				$picinf = "GIF";
			}
			if ($ex eq ".jpg") {
				$picinf = "JPEG";
			}
			if ($ex eq ".png") {
				$picinf = "PNG";
			}

		if ($only) { 
			$only = "（$nam 様専用）"; 
		} else { 
			$only = "（共用アイコン）";
		}

		my $clip;
		# アイコンあり
		if ($ex) {
			if ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{iconurl}/$no-s$ex") {
					$op = qq|src="$cf{iconurl}/$no-s$ex"|;
				} else {
					($w,$h) = ico_resize($w,$h);
					$op = qq|src="$cf{iconurl}/$no$ex" width="$w" height="$h"|;
				}
				my $size = get_size("$cf{iconurl}/$no$ex");
				$clip .= qq|<img $op border="0" hspace="18" alt="">(w$w×h$h <b style="color:#FF9966">$size</b>$ex)|;
			}
		}

		print qq|<div class="article">\n|;
		print qq|<input type="radio" name="no" value="$no">\n|;
		print qq|<span style="color:#ed6d46">[$no]</span> <b>アイコン表\示名：$sub <span style="color:#00afcc">$only</span></b>\n|;
		print qq|<div class="bbs-ico2">$clip</div>\n|;
		print qq|<div class="bbs-com2">$com</div>\n|;
		print qq|<div class="art-info2">登録者：<b>$nam</b> $date</div>\n|;
		print qq|</div>\n|;
	}
	close(IN);

	print <<EOM;
	<div class="clear"></div>
</div>
</form>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  ユーザー登録アイコン修正フォーム
#-----------------------------------------------------------
sub edit_iconfm {
	my ($date,$nam,$sub,$eml,$com,$url,$ex,$icotype) = @_;
	$com =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';

	header("管理モード &gt; 修正フォーム");
	print <<EOM;
<div id="head">
	<div id="head-in">
	<h2>:: $cf{bbs_title}  ::</h2>
	</div>
</div>
<div id="main">
<div id="main-in">
EOM
	back_btn('mente_icon');
	print <<EOM;
<div class="sub-ttl">■ 登録アイコン編集フォーム</div>
<p>▼変更する部分のみ修正して送信ボタンを押して下さい。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}" />
<input type="hidden" name="mente_icon" value="1">
<input type="hidden" name="job" value="edit2" />
<input type="hidden" name="no" value="$in{no}" />
<table class="regfm">
<tr>
	<th>登録者名</th>
	<td><input type="text" name="name" class="reg-name" value="$nam" /></td>
</tr><tr>
	<th>アイコン名称</th>
	<td>
		<input type="text" name="sub" class="reg-name" value="$sub" />
	</td>
</tr><tr>
	<th>アイコンFile</th>
	<td>
EOM
	my $checkbox;
	if ($icotype eq "1") {
		$checkbox = qq|<input type="checkbox" name="icontype" value="1" checked="checked" />\n|;
	} else {
		$checkbox = qq|<input type="checkbox" name="icontype" value="1"  />\n|;
	}

		print qq|&nbsp;&nbsp;&nbsp$checkbox<b style="color:#00afcc">専用タイプ</b><br />\n|;
		print qq|<input type="file" name="upfile" />\n|;

	if ($ex) {
		print qq|<br />[<a href="$cf{iconurl}/$in{no}$ex" target="_blank">添付</a>]&nbsp;\n|;
		print qq|<input type="checkbox" name="imgdel" value="1" style="color:gray; border-width:1px; border-color:rgb(247,185,0); border-style:solid;">削除</td>\n|;
	}

	print <<EOM;
</td>
</tr><tr>
	<th>アイコン説明</th>
    	<td><textarea size="55" name="comment" value="$com"></textarea></td>
</tr><tr>
	<th>Ｅメール</th>
	<td>&nbsp;&nbsp;&nbsp;<input type="text" name="email" class="reg-name" value="$eml" /></td>
</tr><tr>
	<th>参照URL</th>
	<td>&nbsp;&nbsp;&nbsp;<input type="text" class="reg-url" name="url" value="$url" /></td>
</tr><tr>
	<th></th>
	<td>
	    <input type="submit" class="reg-btn" value="修正する" />
	</td>
</tr>
</table>
</form>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  ユーザー登録アイコン・リスト挿入
#-----------------------------------------------------------
sub put_iconlist{

	my @log;
	open(IN,"$cf{iconfile}") or error("open err: $cf{iconfile}");
	while (<IN>) {
		push(@log,$_);
	}
	close(IN);
	foreach (@log) {
		my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$only) = split(/<>/);

		if ($only) { 
			$only = "（$nam 様専用）"; 
		} else { 
			$only = "（共用アイコン）";
		}

		push(@{$cf{icon}},"$no$ex,* $sub $only") if ($cf{user_icon});
	}
}

#-----------------------------------------------------------
#  パスワード認証
#-----------------------------------------------------------
sub check_passwd {
	# パスワードが未入力の場合は入力フォーム画面
	if ($in{pass} eq "") {
		enter_form();

	# パスワード認証
	} elsif ($in{pass} ne $cf{password}) {
		err_msg("認証できません");
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub enter_form {
	header("入室画面");
	print <<EOM;
<div id="head">
	<div id="head-in">
	<h2>:: $cf{bbs_title} ::</h2>
	</div>
</div>
<div align="center">
<form id="login" action="$cf{admin_cgi}" method="post">
    <h1>ADMIN Log In</h1>
    <fieldset id="inputs"><legend>管理パスワード入力</legend>
        <p id="inputs" class="pass"><input id="password" type="password" name="pass" placeholder="Password" autofocus required></p>
    </fieldset>
    <fieldset id="actions">
        <input type="submit" id="submit" value="Log in">
    </fieldset>
</form>
<script language="javascript">
<!--
self.document.forms[0].pass.focus();
//-->
</script>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta http-equiv="content-style-type" content="text/css" />
<meta http-equiv="content-script-type" content="text/javascript" />
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<script type="text/javascript"> 
var ua = navigator.userAgent;
if(ua.indexOf('iPhone') != -1 || ua.indexOf('Android') != -1){
//iPhone & Android
document.write('<link rel="stylesheet" href="cmn/admin-mobile.css">');
}else{
//PC
document.write('<link rel="stylesheet" href="cmn/admin.css">');
}
</script>
	<!-- Add jQuery library -->
	<script type="text/javascript" src="fancyBox/lib/jquery-1.10.1.min.js"></script>

	<!-- Add mousewheel plugin (this is optional) -->
	<script type="text/javascript" src="fancyBox/lib/jquery.mousewheel-3.0.6.pack.js"></script>

	<!-- Add fancyBox main JS and CSS files -->
	<script type="text/javascript" src="fancyBox/source/jquery.fancybox.js?v=2.1.5"></script>
	<link rel="stylesheet" type="text/css" href="fancyBox/source/jquery.fancybox.css?v=2.1.5" media="screen" />

	<!-- Add Button helper (this is optional) -->
	<link rel="stylesheet" type="text/css" href="fancyBox/source/helpers/jquery.fancybox-buttons.css?v=1.0.5" />
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-buttons.js?v=1.0.5"></script>

	<!-- Add Thumbnail helper (this is optional) -->
	<link rel="stylesheet" type="text/css" href="fancyBox/source/helpers/jquery.fancybox-thumbs.css?v=1.0.7" />
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-thumbs.js?v=1.0.7"></script>

	<!-- Add Media helper (this is optional) -->
	<script type="text/javascript" src="fancyBox/source/helpers/jquery.fancybox-media.js?v=1.0.6"></script>
	<script type="text/javascript" src="fancyBox/source/fancybox.js"></script>
	<script type="text/javascript" src="fancyBox/source/jquery.yybbs.fancybox.js"></script>
<title>$ttl</title>
</head>
<body>
EOM
}

#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {
	my $mode = shift;

	print <<EOM;
<div class="ta-r">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
@{[ $mode ? qq|<input type="submit" name="$mode" value="&lt; 前画面">| : "" ]}
<input type="submit" value="▲メニュー">
</form>
</div>
EOM
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	&header("完了");
	print <<EOM;
<div align="center" style="margin-top:3em;">
<hr width="350">
<p class="msg">$msg</p>
<hr width="350">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="hidden" name="mente_log" value="1">
<input type="submit" value="記事管理画面に戻る">
</form>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  アイコン編集・完了メッセージ
#-----------------------------------------------------------
sub ico_message {
	my $msg = shift;

	&header("完了");
	print <<EOM;
<div align="center" style="margin-top:3em;">
<hr width="350">
<p class="msg">$msg</p>
<hr width="350">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="hidden" name="mente_icon" value="1">
<input type="submit" value="アイコン管理画面に戻る">
</form>
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  アイコンアップロード
#-----------------------------------------------------------
sub ico_upload {
	my $no = shift;

	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	# 拡張子取得
	my $ext = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : error("拡張子不明");
	$ext =~ tr/A-Z/a-z/;
	if ($ext eq '.jpeg') { $ext = '.jpg'; }
	if ($ext eq '.text') { $ext = '.txt'; }

	# ファイルチェック
	check_upl($ext);

	# 添付ファイル定義
	my $upfile = "$cf{iconurl}/$no$ext";

	# アップロード書き込み
	open(UP,"+> $upfile") or error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	chmod(0666, $upfile);

	# 画像サイズ取得
	my ($flg,$w,$h);
	if ($ext eq ".jpg") { ($w,$h) = &j_size($upfile); $flg++; }
	elsif ($ext eq ".gif") { ($w,$h) = &g_size($upfile); $flg++; }
	elsif ($ext eq ".png") { ($w,$h) = &p_size($upfile); $flg++; }

	# サムネイル化
	if ($flg && $cf{thumbnail}) {
		($w,$h) = &resize($w,$h);
		my $thumb = "$cf{iconurl}/$no-s$ext";
		make_thumb($upfile,$thumb,$w,$h);
	}

	# 結果を返す
	return ($ext,$w,$h);
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub err_msg {
	my $err = shift;

	header("ERROR");
	print <<EOM;
<div class="ta-c">
<hr width="350" />
<h3>ERROR!</h3>
<p class="red">$err</p>
<hr width="350" />
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  文字カット for UTF-8
#  [quote] http://linkage.white-void.net/development/server/perl-utf8-strcut.html
#-----------------------------------------------------------
sub strcutbytes_utf8 {
	my ($src,$maxlen) = @_;
	$src =~ s/[\t\n]//g;
	$src =~ s|<br( /)?>|\n|g;
	
	my $srclen = length($src);
	my $srcpos = 0;
	while($srcpos < $srclen) {
		my $character = substr($src, $srcpos, 1);
		my $value = ord($character);
		if($value < 0x80) { # ASCII characters
			$srcpos++;
			next;
		}
		my $width = 6;
		$width = 5 if ($value < 0xFC);
		$width = 4 if ($value < 0xF8);
		$width = 3 if ($value < 0xF0);
		$width = 2 if ($value < 0xE0);
		my $nextpos = $srcpos + $width;
		last if($nextpos > $maxlen);
		last if($nextpos > $srclen); # sequence is incomplete
		$srcpos = $nextpos;
	}
	return substr($src, 0, $srcpos);
}
#-----------------------------------------------------------
#  著作権表記（削除・改変を禁ず）
#-----------------------------------------------------------
sub footer {
	my ($foot) = @_;
	
	my $copy = <<EOM;
<p style="margin-top:3em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
	- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br />++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

